/*

	File:		ErrorReporter.cp
	Project:	Sprocket Framework 1.1 fc1 of 5/10/96
	Contains:	Simple error reporting function
	To Do:		?

	Sprocket Major Contributors:
	----------------------------
	Dave Falkenburg, producer of Sprocket 1.0
	Bill Hayden,	 producer of Sprocket 1.1
	Steve Sisak,	 producer of the upcoming Sprocket 2.0
	
	Pete Alexander		Steve Falkenburg		Randy Thelen
	Eric Berdahl		Nitin Ganatra			Leonard Rosenthal
	Marshall Clow		Dave Hershey			Dean Yu
	Tim Craycroft		Dave Mark				
	David denBoer		Gary Powell
	Cameron Esfahani	Jon Summers				Apple Computer, Inc.
		
	Comments, Additions, or Corrections:
	------------------------------------
	Bill Hayden, Nikol Software <nikol@codewell.com>

*/


#include "SprocketConstants.h"
#include "UString.h"
#include "UDialog.h"
#include "ErrorReporter.h"


/*****************************************************************************/



TErrorReporter::TErrorReporter(OSErr err, char* file, long line)
{
	Str255	errStr, lineStr;
	
	NumToString(err, errStr);
	NumToString(line, lineStr);
	c2p(file);

#if qDebug
	//SysBreakStr("\pError State: TErrorReporter Called");
#endif
	
	ParamText(errStr, (StringPtr)file, lineStr, "\p");
	
	SetCursor(&qd.arrow);
	StandardAlert(kErrorReporterAlertID);
	
	p2c((StringPtr)file);
}


TErrorReporter::~TErrorReporter()
{
}

