/*

	File:		SortedDynamicArray.cp
	Project:	Sprocket Framework 1.1 (DR2), released 6/15/96
	Contains:	Sub-class of TDynamicArray which provides sorting and finding
	To Do:		?

	Sprocket Major Contributors:
	----------------------------
	Dave Falkenburg, producer of Sprocket 1.0
	Bill Hayden,	 producer of Sprocket 1.1
	Steve Sisak,	 producer of the upcoming Sprocket 2.0
	
	Pete Alexander		Steve Falkenburg	Randy Thelen
	Eric Berdahl		Nitin Ganatra		Chris K. Thomas
	Marshall Clow		Dave Hershey		Leonard Rosenthal
	Tim Craycroft		Dave Mark			Dean Yu
	David denBoer		Gary Powell
	Cameron Esfahani	Jon Summers			Apple Computer, Inc.
		
	Comments, Additions, or Corrections:
	------------------------------------
	Bill Hayden, Nikol Software <nikol@codewell.com>

*/

#include	"SortedDynamicArray.h"

TSortedDynamicArray::TSortedDynamicArray()
	{
	}


//	TSortedDynamicArray::Add
//
//	An O(n) (insertion sort) routine for adding elements

OSErr
TSortedDynamicArray::Add(ArrayElementPtr newElement)
	{
	ArrayElementIndex	index;

	for (index = 0;index < fElementCount;index++)
		{
		if (this->Compare(newElement,(*fStorage)[index]) > 0)
			continue;

		return this->Insert(newElement,index);
		}

	return this->InsertLast(newElement);
	}


//	TSortedDynamicArray::Find
//
//	A O(lg n) (binary search) routine for finding elements

ArrayElementPtr
TSortedDynamicArray::Find(ArrayElementPtr prototypeElement)
	{
	ArrayElementIndex	low,high,index;
	long				value;
	
	low = 0;
	high = fElementCount;
	
	while (low < high)
		{
		index = (low+high)/2;
		value = this->Compare(prototypeElement,(*fStorage)[index]);
		
		if (value < 0)
			high = index;					//	element is below "high"
		else if (value == 0)
			return (*fStorage)[index];		//	found the element
		else
			low = index+1;					//	element is above "low"
		}

	return NULL;
	}
